#!/bin/bash

set -e

# Import external functions
chmod +x ./devops/PipeLines/Functions.deploy.sh
source ./devops/PipeLines/Functions.deploy.sh

GetAppName appName
echo ""
echo "Continuous integration for ${appName} starting..."

echo ""
echo "${appName} building..."
GetSolutionName solutionName
dotnet build ${solutionName}	 

echo ""
echo "Please check the version of each microservice carefully !!!"

#GetServices services
for servicePrefix in `ls ./src/Services|xargs -d '/'`
do
	GetServiceName ${servicePrefix} serviceName
	GetServiceCsProjFile ${servicePrefix} ${serviceName} serviceCsProjFile
	CI ${serviceName} ${serviceCsProjFile}
done

echo ""
echo "Continuous integration for ${appName} has been successful."